##===- TEST.feature-extraction.Makefile ------------------------------*- Makefile -*-===##
#
###############
# J-Dawg AKA "The Bladderman"
###################
# This recursively traverses the programs, and runs the -simplify-libcalls pass
# on each *.linked.rbc bytecode file with -stats set so that it is possible to
# determine which libcalls are being optimized in which programs.
# 
# Usage: 
#### NOT FUNCTIONAL     make TEST=feature-extraction summary (short summary)
#     make TEST=feature-extraction (detailed list with time passes, etc.)
#     make TEST=feature-extraction report
#     make TEST=feature-extraction report.html
#
##===----------------------------------------------------------------------===##

CURDIR  := $(shell cd .; pwd)
PROGDIR := $(PROJ_SRC_ROOT)
RELDIR  := $(subst $(PROGDIR),,$(CURDIR))

TEST_NAME = $*

$(PROGRAMS_TO_TEST:%=test.$(TEST).%) : test.$(TEST).% : test.crap.% $(PROJ_SRC_ROOT)/TEST.$(TEST).Makefile 
	@rm -f $@
	@echo Grepping test.opt\|unopt.$(TEST_NAME)
	@cat test.opt.$(TEST_NAME) | grep real | sed -e "s/real[	 ]*0m\([0-9.]*\).*/\1/g" > $@.tmp
	@python $(PROJ_SRC_ROOT)/sum.py $@.tmp > $@
	@cat test.unopt.$(TEST_NAME) | grep real | sed -e "s/real[	 ]*0m\([0-9.]*\).*/\1/g" > $@.tmp
	@python $(PROJ_SRC_ROOT)/sum.py $@.tmp >> $@
	@rm $@.tmp
#	@cat test.crap.$(TEST_NAME).$(TEST_NUM) | grep real | sed -e "s/real[		]*0m\([0-9.]*\).*/\1/g" > $@
#	@cp $@ $@.$(TEST_NUM)
#	@python $(PROJ_SRC_ROOT)/sum.py $@.$(TEST_NUM)

REPORT_DEPENDENCIES := $(LOPT)